﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class init : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "AwaitDummies",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_AwaitDummies", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "ContentTypes",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Type = table.Column<string>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ContentTypes", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Tags",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Tags", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "TestCaseSettingses",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MaxDiskSpaceInKb = table.Column<int>(nullable: false),
                    MemoryLimitInKb = table.Column<int>(nullable: false),
                    TimeoutInMs = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestCaseSettingses", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "TestTypes",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    InternalName = table.Column<string>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestTypes", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Langs",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    Language = table.Column<string>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Langs", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "PLangs",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    InternalName = table.Column<string>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_PLangs", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "GroupRolePermissions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CanAddUserToGroup = table.Column<bool>(nullable: false),
                    CanAssessExercises = table.Column<bool>(nullable: false),
                    CanChangeExercises = table.Column<bool>(nullable: false),
                    CanChangeOtherMembersRole = table.Column<bool>(nullable: false),
                    CanCopyExercises = table.Column<bool>(nullable: false),
                    CanCreateExercises = table.Column<bool>(nullable: false),
                    CanDeleteExercises = table.Column<bool>(nullable: false),
                    CanExportExerciseResults = table.Column<bool>(nullable: false),
                    CanReleaseExercises = table.Column<bool>(nullable: false),
                    CanRemoveMemberFromGroup = table.Column<bool>(nullable: false),
                    CanSeeExercisesFromOthersInGroup = table.Column<bool>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_GroupRolePermissions", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "LdapUsers",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_LdapUsers", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "CodeEditorSettings",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    FontSize = table.Column<int>(nullable: false),
                    HighlightCurrentLine = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    ShowInvisibles = table.Column<bool>(nullable: false),
                    ShowLineIndentions = table.Column<bool>(nullable: false),
                    ShowLineNumbers = table.Column<bool>(nullable: false),
                    TabSize = table.Column<int>(nullable: false),
                    Theme = table.Column<string>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CodeEditorSettings", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "SystemRolePermissions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CanChangeGroups = table.Column<bool>(nullable: false),
                    CanChangeOtherUsersSystemRole = table.Column<bool>(nullable: false),
                    CanChangeRoles = table.Column<bool>(nullable: false),
                    CanChangeSystemSettings = table.Column<bool>(nullable: false),
                    CanCreateGroups = table.Column<bool>(nullable: false),
                    CanCreateRoles = table.Column<bool>(nullable: false),
                    CanDeleteActivatedUsers = table.Column<bool>(nullable: false),
                    CanDeleteGroups = table.Column<bool>(nullable: false),
                    CanDeleteRoles = table.Column<bool>(nullable: false),
                    CanManageNewUsers = table.Column<bool>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SystemRolePermissions", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "UserGroups",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    Email = table.Column<string>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_UserGroups", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "GroupRoles",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    GroupRolePermissionId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_GroupRoles", x => x.Id);
                    table.ForeignKey(
                        name: "FK_GroupRoles_GroupRolePermissions_GroupRolePermissionId",
                        column: x => x.GroupRolePermissionId,
                        principalTable: "GroupRolePermissions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "SystemRoles",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    Email = table.Column<string>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    SystemRolePermissionId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SystemRoles", x => x.Id);
                    table.ForeignKey(
                        name: "FK_SystemRoles_SystemRolePermissions_SystemRolePermissionId",
                        column: x => x.SystemRolePermissionId,
                        principalTable: "SystemRolePermissions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "SystemSettings",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DefaultGroupCreatorGroupRoleId = table.Column<int>(nullable: false),
                    DefaultGroupRoleId = table.Column<int>(nullable: false),
                    DefaultUserGroupId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MaxSolutionVersionsPerUser = table.Column<int>(nullable: false, defaultValue: 10)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SystemSettings", x => x.Id);
                    table.ForeignKey(
                        name: "FK_SystemSettings_GroupRoles_DefaultGroupCreatorGroupRoleId",
                        column: x => x.DefaultGroupCreatorGroupRoleId,
                        principalTable: "GroupRoles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                    table.ForeignKey(
                        name: "FK_SystemSettings_GroupRoles_DefaultGroupRoleId",
                        column: x => x.DefaultGroupRoleId,
                        principalTable: "GroupRoles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                    table.ForeignKey(
                        name: "FK_SystemSettings_UserGroups_DefaultUserGroupId",
                        column: x => x.DefaultUserGroupId,
                        principalTable: "UserGroups",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                });

            migrationBuilder.CreateTable(
                name: "Users",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    Email = table.Column<string>(nullable: true),
                    FirstName = table.Column<string>(nullable: true),
                    IsActivated = table.Column<bool>(nullable: false),
                    LastLoginAt = table.Column<DateTime>(nullable: false),
                    LastName = table.Column<string>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    LdapUserId = table.Column<int>(nullable: true),
                    Password = table.Column<string>(nullable: true),
                    StudentNumber = table.Column<string>(nullable: true),
                    SystemRoleId = table.Column<int>(nullable: true),
                    Token = table.Column<string>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Users", x => x.Id);
                    table.UniqueConstraint("Unique_Token", x => x.Token);
                    table.ForeignKey(
                        name: "FK_Users_LdapUsers_LdapUserId",
                        column: x => x.LdapUserId,
                        principalTable: "LdapUsers",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_Users_SystemRoles_SystemRoleId",
                        column: x => x.SystemRoleId,
                        principalTable: "SystemRoles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                });

            migrationBuilder.CreateTable(
                name: "Exercises",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CanUserCreateCustomTests = table.Column<bool>(nullable: false),
                    CanUserCreateFiles = table.Column<bool>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    IsOnlyVisibleToMe = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    ShortDescription = table.Column<string>(nullable: true),
                    ShouldShowSubmitResult = table.Column<bool>(nullable: false),
                    UserGroupId = table.Column<int>(nullable: false),
                    UserId = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Exercises", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Exercises_UserGroups_UserGroupId",
                        column: x => x.UserGroupId,
                        principalTable: "UserGroups",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_Exercises_Users_UserId",
                        column: x => x.UserId,
                        principalTable: "Users",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                });

            migrationBuilder.CreateTable(
                name: "UserSettingses",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CodeEditorSettingsId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LangId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    UserId = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_UserSettingses", x => x.Id);
                    table.ForeignKey(
                        name: "FK_UserSettingses_CodeEditorSettings_CodeEditorSettingsId",
                        column: x => x.CodeEditorSettingsId,
                        principalTable: "CodeEditorSettings",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_UserSettingses_Langs_LangId",
                        column: x => x.LangId,
                        principalTable: "Langs",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                    table.ForeignKey(
                        name: "FK_UserSettingses_Users_UserId",
                        column: x => x.UserId,
                        principalTable: "Users",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "UserWithUserGroups",
                columns: table => new
                {
                    UserId = table.Column<int>(nullable: false),
                    UserGroupId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    GroupRoleId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_UserWithUserGroups", x => new { x.UserId, x.UserGroupId });
                    table.ForeignKey(
                        name: "FK_UserWithUserGroups_GroupRoles_GroupRoleId",
                        column: x => x.GroupRoleId,
                        principalTable: "GroupRoles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_UserWithUserGroups_UserGroups_UserGroupId",
                        column: x => x.UserGroupId,
                        principalTable: "UserGroups",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_UserWithUserGroups_Users_UserId",
                        column: x => x.UserId,
                        principalTable: "Users",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "ExerciseDescriptions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    Content = table.Column<string>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    ExerciseId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ExerciseDescriptions", x => x.Id);
                    table.ForeignKey(
                        name: "FK_ExerciseDescriptions_Exercises_ExerciseId",
                        column: x => x.ExerciseId,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "MetaDatas",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    ExerciseId = table.Column<int>(nullable: false),
                    ExerciseId1 = table.Column<int>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_MetaDatas", x => x.Id);
                    table.ForeignKey(
                        name: "FK_MetaDatas_Exercises_ExerciseId",
                        column: x => x.ExerciseId,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_MetaDatas_Exercises_ExerciseId1",
                        column: x => x.ExerciseId1,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "ExerciseReleases",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    AutomaticEndAt = table.Column<DateTime>(nullable: true),
                    AutomaticStartAt = table.Column<DateTime>(nullable: true),
                    AvailableWorkingTimeInMinutes = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    ExerciseId = table.Column<int>(nullable: false),
                    GeneratedCode = table.Column<string>(nullable: false),
                    HasLimitedWorkingTime = table.Column<bool>(nullable: false),
                    IsReleased = table.Column<bool>(nullable: false),
                    IsVisibleToAllAfterRelease = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Note = table.Column<string>(nullable: true),
                    PLangId = table.Column<int>(nullable: true),
                    ReleaseDurationType = table.Column<int>(nullable: false),
                    ReleaseStartType = table.Column<int>(nullable: false),
                    ReleasedAt = table.Column<DateTime>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ExerciseReleases", x => x.Id);
                    table.UniqueConstraint("Unique_GeneratedCode", x => x.GeneratedCode);
                    table.ForeignKey(
                        name: "FK_ExerciseReleases_Exercises_ExerciseId",
                        column: x => x.ExerciseId,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_ExerciseReleases_PLangs_PLangId",
                        column: x => x.PLangId,
                        principalTable: "PLangs",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                });

            migrationBuilder.CreateTable(
                name: "DefaultCustomTestSettings",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    ExerciseId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MaxDiskSpaceInKb = table.Column<int>(nullable: false),
                    MemoryLimitInKb = table.Column<int>(nullable: false),
                    TimeoutInMs = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_DefaultCustomTestSettings", x => x.Id);
                    table.ForeignKey(
                        name: "FK_DefaultCustomTestSettings_Exercises_ExerciseId",
                        column: x => x.ExerciseId,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "Tests",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    Content = table.Column<string>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    ExerciseId = table.Column<int>(nullable: false),
                    IsSubmitTest = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    TestSettingsId = table.Column<int>(nullable: false),
                    TestTypeId = table.Column<int>(nullable: false),
                    Weight = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Tests", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Tests_Exercises_ExerciseId",
                        column: x => x.ExerciseId,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_Tests_TestCaseSettingses_TestSettingsId",
                        column: x => x.TestSettingsId,
                        principalTable: "TestCaseSettingses",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_Tests_TestTypes_TestTypeId",
                        column: x => x.TestTypeId,
                        principalTable: "TestTypes",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "Assets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    AssetUrl = table.Column<string>(nullable: true),
                    Content = table.Column<byte[]>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    ExerciseDescriptionId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Assets", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Assets_ExerciseDescriptions_ExerciseDescriptionId",
                        column: x => x.ExerciseDescriptionId,
                        principalTable: "ExerciseDescriptions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "TagWithMetaDatas",
                columns: table => new
                {
                    TagId = table.Column<int>(nullable: false),
                    MetaDataId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TagWithMetaDatas", x => new { x.TagId, x.MetaDataId });
                    table.ForeignKey(
                        name: "FK_TagWithMetaDatas_MetaDatas_MetaDataId",
                        column: x => x.MetaDataId,
                        principalTable: "MetaDatas",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_TagWithMetaDatas_Tags_TagId",
                        column: x => x.TagId,
                        principalTable: "Tags",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Restrict);
                });

            migrationBuilder.CreateTable(
                name: "ExerciseReleaseWithUserAsParticipations",
                columns: table => new
                {
                    UserId = table.Column<int>(nullable: false),
                    ExerciseReleaseId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastEditedPLangId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ExerciseReleaseWithUserAsParticipations", x => new { x.UserId, x.ExerciseReleaseId });
                    table.ForeignKey(
                        name: "FK_ExerciseReleaseWithUserAsParticipations_ExerciseReleases_ExerciseReleaseId",
                        column: x => x.ExerciseReleaseId,
                        principalTable: "ExerciseReleases",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_ExerciseReleaseWithUserAsParticipations_PLangs_LastEditedPLangId",
                        column: x => x.LastEditedPLangId,
                        principalTable: "PLangs",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                    table.ForeignKey(
                        name: "FK_ExerciseReleaseWithUserAsParticipations_Users_UserId",
                        column: x => x.UserId,
                        principalTable: "Users",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "TestAssets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    Content = table.Column<byte[]>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(nullable: true),
                    TestId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestAssets", x => x.Id);
                    table.ForeignKey(
                        name: "FK_TestAssets_Tests_TestId",
                        column: x => x.TestId,
                        principalTable: "Tests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomTest",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    Content = table.Column<string>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    ExerciseReleaseId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    TestTypeId = table.Column<int>(nullable: false),
                    UserId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomTest", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomTest_TestTypes_TestTypeId",
                        column: x => x.TestTypeId,
                        principalTable: "TestTypes",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomTest_ExerciseReleaseWithUserAsParticipations_UserId_ExerciseReleaseId",
                        columns: x => new { x.UserId, x.ExerciseReleaseId },
                        principalTable: "ExerciseReleaseWithUserAsParticipations",
                        principalColumns: new[] { "UserId", "ExerciseReleaseId" },
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomTestAssets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    Content = table.Column<byte[]>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    CustomTestId = table.Column<int>(nullable: false),
                    DisplayName = table.Column<string>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomTestAssets", x => x.Id);
                    table.ForeignKey(
                        name: "FK_CustomTestAssets_CustomTest_CustomTestId",
                        column: x => x.CustomTestId,
                        principalTable: "CustomTest",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "TemplateFiles",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CodeTemplateId = table.Column<int>(nullable: false),
                    Content = table.Column<string>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    FileNameWithExtension = table.Column<string>(nullable: true),
                    IsEditableByUser = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TemplateFiles", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Templates",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    ExerciseId = table.Column<int>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MainFileId = table.Column<int>(nullable: true),
                    PLangId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Templates", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Templates_Exercises_ExerciseId",
                        column: x => x.ExerciseId,
                        principalTable: "Exercises",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_Templates_TemplateFiles_MainFileId",
                        column: x => x.MainFileId,
                        principalTable: "TemplateFiles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                    table.ForeignKey(
                        name: "FK_Templates_PLangs_PLangId",
                        column: x => x.PLangId,
                        principalTable: "PLangs",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                });

            migrationBuilder.CreateTable(
                name: "Solutions",
                columns: table => new
                {
                    UserId = table.Column<int>(nullable: false),
                    ExerciseReleaseId = table.Column<int>(nullable: false),
                    PLangId = table.Column<int>(nullable: false),
                    AssessmentId = table.Column<int>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MainSolutionVersionid = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Solutions", x => new { x.UserId, x.ExerciseReleaseId, x.PLangId });
                    table.ForeignKey(
                        name: "FK_Solutions_PLangs_PLangId",
                        column: x => x.PLangId,
                        principalTable: "PLangs",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                    table.ForeignKey(
                        name: "FK_Solutions_ExerciseReleaseWithUserAsParticipations_UserId_ExerciseReleaseId",
                        columns: x => new { x.UserId, x.ExerciseReleaseId },
                        principalTable: "ExerciseReleaseWithUserAsParticipations",
                        principalColumns: new[] { "UserId", "ExerciseReleaseId" },
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "SolutionVersions",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MainFileId = table.Column<int>(nullable: true),
                    Note = table.Column<string>(nullable: true),
                    SolutionExerciseReleaseId = table.Column<int>(nullable: false),
                    SolutionPLangId = table.Column<int>(nullable: false),
                    SolutionUserId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SolutionVersions", x => x.Id);
                    table.ForeignKey(
                        name: "FK_SolutionVersions_Solutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                        columns: x => new { x.SolutionUserId, x.SolutionExerciseReleaseId, x.SolutionPLangId },
                        principalTable: "Solutions",
                        principalColumns: new[] { "UserId", "ExerciseReleaseId", "PLangId" },
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "CustomTestWithSolutionAsTestResults",
                columns: table => new
                {
                    CustomTestId = table.Column<int>(nullable: false),
                    SolutionVersionId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(nullable: true),
                    TestResultCode = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomTestWithSolutionAsTestResults", x => new { x.CustomTestId, x.SolutionVersionId });
                    table.ForeignKey(
                        name: "FK_CustomTestWithSolutionAsTestResults_CustomTest_CustomTestId",
                        column: x => x.CustomTestId,
                        principalTable: "CustomTest",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomTestWithSolutionAsTestResults_SolutionVersions_SolutionVersionId",
                        column: x => x.SolutionVersionId,
                        principalTable: "SolutionVersions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "SolutionAssessment",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    ManualPoints = table.Column<int>(nullable: true),
                    MaxNormalTestPoints = table.Column<int>(nullable: false),
                    MaxSubmitTestPoints = table.Column<int>(nullable: false),
                    NormalTestPoints = table.Column<int>(nullable: false),
                    Note = table.Column<string>(nullable: true),
                    SolutionVersionId = table.Column<int>(nullable: false),
                    SubmitTestPoints = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SolutionAssessment", x => x.Id);
                    table.ForeignKey(
                        name: "FK_SolutionAssessment_SolutionVersions_SolutionVersionId",
                        column: x => x.SolutionVersionId,
                        principalTable: "SolutionVersions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "SolutionFiles",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    Content = table.Column<string>(nullable: true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    DisplayIndex = table.Column<int>(nullable: false),
                    FileNameWithExtension = table.Column<string>(nullable: true),
                    IsDisplayed = table.Column<bool>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    SolutionVersionId = table.Column<int>(nullable: false),
                    TemplateFileId = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_SolutionFiles", x => x.Id);
                    table.ForeignKey(
                        name: "FK_SolutionFiles_SolutionVersions_SolutionVersionId",
                        column: x => x.SolutionVersionId,
                        principalTable: "SolutionVersions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_SolutionFiles_TemplateFiles_TemplateFileId",
                        column: x => x.TemplateFileId,
                        principalTable: "TemplateFiles",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.SetNull);
                });

            migrationBuilder.CreateTable(
                name: "TestResults",
                columns: table => new
                {
                    TestId = table.Column<int>(nullable: false),
                    SolutionVersionId = table.Column<int>(nullable: false),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(nullable: true),
                    TestResultCode = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestResults", x => new { x.TestId, x.SolutionVersionId });
                    table.ForeignKey(
                        name: "FK_TestResults_SolutionVersions_SolutionVersionId",
                        column: x => x.SolutionVersionId,
                        principalTable: "SolutionVersions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_TestResults_Tests_TestId",
                        column: x => x.TestId,
                        principalTable: "Tests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_Assets_ExerciseDescriptionId",
                table: "Assets",
                column: "ExerciseDescriptionId");

            migrationBuilder.CreateIndex(
                name: "IX_Templates_ExerciseId",
                table: "Templates",
                column: "ExerciseId");

            migrationBuilder.CreateIndex(
                name: "IX_Templates_MainFileId",
                table: "Templates",
                column: "MainFileId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Templates_PLangId",
                table: "Templates",
                column: "PLangId");

            migrationBuilder.CreateIndex(
                name: "IX_Exercises_UserGroupId",
                table: "Exercises",
                column: "UserGroupId");

            migrationBuilder.CreateIndex(
                name: "IX_Exercises_UserId",
                table: "Exercises",
                column: "UserId");

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseDescriptions_ExerciseId",
                table: "ExerciseDescriptions",
                column: "ExerciseId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_MetaDatas_ExerciseId",
                table: "MetaDatas",
                column: "ExerciseId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_MetaDatas_ExerciseId1",
                table: "MetaDatas",
                column: "ExerciseId1");

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseReleases_ExerciseId",
                table: "ExerciseReleases",
                column: "ExerciseId");

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseReleases_PLangId",
                table: "ExerciseReleases",
                column: "PLangId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithSolutionAsTestResults_CustomTestId",
                table: "CustomTestWithSolutionAsTestResults",
                column: "CustomTestId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithSolutionAsTestResults_SolutionVersionId",
                table: "CustomTestWithSolutionAsTestResults",
                column: "SolutionVersionId");

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseReleaseWithUserAsParticipations_ExerciseReleaseId",
                table: "ExerciseReleaseWithUserAsParticipations",
                column: "ExerciseReleaseId");

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseReleaseWithUserAsParticipations_LastEditedPLangId",
                table: "ExerciseReleaseWithUserAsParticipations",
                column: "LastEditedPLangId");

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseReleaseWithUserAsParticipations_UserId",
                table: "ExerciseReleaseWithUserAsParticipations",
                column: "UserId");

            migrationBuilder.CreateIndex(
                name: "IX_Solutions_AssessmentId",
                table: "Solutions",
                column: "AssessmentId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Solutions_PLangId",
                table: "Solutions",
                column: "PLangId");

            migrationBuilder.CreateIndex(
                name: "IX_Solutions_UserId_ExerciseReleaseId",
                table: "Solutions",
                columns: new[] { "UserId", "ExerciseReleaseId" });

            migrationBuilder.CreateIndex(
                name: "IX_SolutionAssessment_SolutionVersionId",
                table: "SolutionAssessment",
                column: "SolutionVersionId");

            migrationBuilder.CreateIndex(
                name: "IX_SolutionFiles_SolutionVersionId",
                table: "SolutionFiles",
                column: "SolutionVersionId");

            migrationBuilder.CreateIndex(
                name: "IX_SolutionFiles_TemplateFileId",
                table: "SolutionFiles",
                column: "TemplateFileId");

            migrationBuilder.CreateIndex(
                name: "IX_SolutionVersions_MainFileId",
                table: "SolutionVersions",
                column: "MainFileId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_SolutionVersions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "SolutionVersions",
                columns: new[] { "SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId" });

            migrationBuilder.CreateIndex(
                name: "IX_TestResults_SolutionVersionId",
                table: "TestResults",
                column: "SolutionVersionId");

            migrationBuilder.CreateIndex(
                name: "IX_TestResults_TestId",
                table: "TestResults",
                column: "TestId");

            migrationBuilder.CreateIndex(
                name: "IX_TagWithMetaDatas_MetaDataId",
                table: "TagWithMetaDatas",
                column: "MetaDataId");

            migrationBuilder.CreateIndex(
                name: "IX_TagWithMetaDatas_TagId",
                table: "TagWithMetaDatas",
                column: "TagId");

            migrationBuilder.CreateIndex(
                name: "IX_TemplateFiles_CodeTemplateId",
                table: "TemplateFiles",
                column: "CodeTemplateId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTest_TestTypeId",
                table: "CustomTest",
                column: "TestTypeId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTest_UserId_ExerciseReleaseId",
                table: "CustomTest",
                columns: new[] { "UserId", "ExerciseReleaseId" });

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestAssets_CustomTestId",
                table: "CustomTestAssets",
                column: "CustomTestId");

            migrationBuilder.CreateIndex(
                name: "IX_DefaultCustomTestSettings_ExerciseId",
                table: "DefaultCustomTestSettings",
                column: "ExerciseId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Tests_ExerciseId",
                table: "Tests",
                column: "ExerciseId");

            migrationBuilder.CreateIndex(
                name: "IX_Tests_TestSettingsId",
                table: "Tests",
                column: "TestSettingsId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Tests_TestTypeId",
                table: "Tests",
                column: "TestTypeId");

            migrationBuilder.CreateIndex(
                name: "IX_TestAssets_TestId",
                table: "TestAssets",
                column: "TestId");

            migrationBuilder.CreateIndex(
                name: "IX_GroupRoles_GroupRolePermissionId",
                table: "GroupRoles",
                column: "GroupRolePermissionId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_UserSettingses_CodeEditorSettingsId",
                table: "UserSettingses",
                column: "CodeEditorSettingsId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_UserSettingses_LangId",
                table: "UserSettingses",
                column: "LangId");

            migrationBuilder.CreateIndex(
                name: "IX_UserSettingses_UserId",
                table: "UserSettingses",
                column: "UserId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_SystemRoles_SystemRolePermissionId",
                table: "SystemRoles",
                column: "SystemRolePermissionId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_SystemSettings_DefaultGroupCreatorGroupRoleId",
                table: "SystemSettings",
                column: "DefaultGroupCreatorGroupRoleId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_SystemSettings_DefaultGroupRoleId",
                table: "SystemSettings",
                column: "DefaultGroupRoleId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_SystemSettings_DefaultUserGroupId",
                table: "SystemSettings",
                column: "DefaultUserGroupId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Users_LdapUserId",
                table: "Users",
                column: "LdapUserId",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "IX_Users_SystemRoleId",
                table: "Users",
                column: "SystemRoleId");

            migrationBuilder.CreateIndex(
                name: "IX_UserWithUserGroups_GroupRoleId",
                table: "UserWithUserGroups",
                column: "GroupRoleId");

            migrationBuilder.CreateIndex(
                name: "IX_UserWithUserGroups_UserGroupId",
                table: "UserWithUserGroups",
                column: "UserGroupId");

            migrationBuilder.CreateIndex(
                name: "IX_UserWithUserGroups_UserId",
                table: "UserWithUserGroups",
                column: "UserId");

            migrationBuilder.AddForeignKey(
                name: "FK_TemplateFiles_Templates_CodeTemplateId",
                table: "TemplateFiles",
                column: "CodeTemplateId",
                principalTable: "Templates",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_Solutions_SolutionAssessment_AssessmentId",
                table: "Solutions",
                column: "AssessmentId",
                principalTable: "SolutionAssessment",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_SolutionVersions_SolutionFiles_MainFileId",
                table: "SolutionVersions",
                column: "MainFileId",
                principalTable: "SolutionFiles",
                principalColumn: "Id",
                onDelete: ReferentialAction.SetNull);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_Templates_Exercises_ExerciseId",
                table: "Templates");

            migrationBuilder.DropForeignKey(
                name: "FK_ExerciseReleases_Exercises_ExerciseId",
                table: "ExerciseReleases");

            migrationBuilder.DropForeignKey(
                name: "FK_Templates_TemplateFiles_MainFileId",
                table: "Templates");

            migrationBuilder.DropForeignKey(
                name: "FK_SolutionFiles_TemplateFiles_TemplateFileId",
                table: "SolutionFiles");

            migrationBuilder.DropForeignKey(
                name: "FK_ExerciseReleases_PLangs_PLangId",
                table: "ExerciseReleases");

            migrationBuilder.DropForeignKey(
                name: "FK_ExerciseReleaseWithUserAsParticipations_PLangs_LastEditedPLangId",
                table: "ExerciseReleaseWithUserAsParticipations");

            migrationBuilder.DropForeignKey(
                name: "FK_Solutions_PLangs_PLangId",
                table: "Solutions");

            migrationBuilder.DropForeignKey(
                name: "FK_ExerciseReleaseWithUserAsParticipations_Users_UserId",
                table: "ExerciseReleaseWithUserAsParticipations");

            migrationBuilder.DropForeignKey(
                name: "FK_SolutionAssessment_SolutionVersions_SolutionVersionId",
                table: "SolutionAssessment");

            migrationBuilder.DropForeignKey(
                name: "FK_SolutionFiles_SolutionVersions_SolutionVersionId",
                table: "SolutionFiles");

            migrationBuilder.DropTable(
                name: "AwaitDummies");

            migrationBuilder.DropTable(
                name: "ContentTypes");

            migrationBuilder.DropTable(
                name: "Assets");

            migrationBuilder.DropTable(
                name: "CustomTestWithSolutionAsTestResults");

            migrationBuilder.DropTable(
                name: "TestResults");

            migrationBuilder.DropTable(
                name: "TagWithMetaDatas");

            migrationBuilder.DropTable(
                name: "CustomTestAssets");

            migrationBuilder.DropTable(
                name: "DefaultCustomTestSettings");

            migrationBuilder.DropTable(
                name: "TestAssets");

            migrationBuilder.DropTable(
                name: "UserSettingses");

            migrationBuilder.DropTable(
                name: "SystemSettings");

            migrationBuilder.DropTable(
                name: "UserWithUserGroups");

            migrationBuilder.DropTable(
                name: "ExerciseDescriptions");

            migrationBuilder.DropTable(
                name: "MetaDatas");

            migrationBuilder.DropTable(
                name: "Tags");

            migrationBuilder.DropTable(
                name: "CustomTest");

            migrationBuilder.DropTable(
                name: "Tests");

            migrationBuilder.DropTable(
                name: "CodeEditorSettings");

            migrationBuilder.DropTable(
                name: "Langs");

            migrationBuilder.DropTable(
                name: "GroupRoles");

            migrationBuilder.DropTable(
                name: "TestCaseSettingses");

            migrationBuilder.DropTable(
                name: "TestTypes");

            migrationBuilder.DropTable(
                name: "GroupRolePermissions");

            migrationBuilder.DropTable(
                name: "Exercises");

            migrationBuilder.DropTable(
                name: "UserGroups");

            migrationBuilder.DropTable(
                name: "TemplateFiles");

            migrationBuilder.DropTable(
                name: "Templates");

            migrationBuilder.DropTable(
                name: "PLangs");

            migrationBuilder.DropTable(
                name: "Users");

            migrationBuilder.DropTable(
                name: "LdapUsers");

            migrationBuilder.DropTable(
                name: "SystemRoles");

            migrationBuilder.DropTable(
                name: "SystemRolePermissions");

            migrationBuilder.DropTable(
                name: "SolutionVersions");

            migrationBuilder.DropTable(
                name: "SolutionFiles");

            migrationBuilder.DropTable(
                name: "Solutions");

            migrationBuilder.DropTable(
                name: "SolutionAssessment");

            migrationBuilder.DropTable(
                name: "ExerciseReleaseWithUserAsParticipations");

            migrationBuilder.DropTable(
                name: "ExerciseReleases");
        }
    }
}
