﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class SetStringMaxLengths : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "ContentTypes");

            migrationBuilder.AlterColumn<string>(
                name: "Email",
                table: "UserGroups",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "UserGroups",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Token",
                table: "Users",
                maxLength: 500,
                nullable: false);

            migrationBuilder.AlterColumn<string>(
                name: "Password",
                table: "Users",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "LastName",
                table: "Users",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FirstName",
                table: "Users",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Email",
                table: "Users",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Email",
                table: "SystemRoles",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "SystemRoles",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Theme",
                table: "UserSettingses",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Theme",
                table: "CodeEditorSettings",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "GroupRoles",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Token",
                table: "ExternalUsers",
                maxLength: 500,
                nullable: false);

            migrationBuilder.AlterColumn<string>(
                name: "LastName",
                table: "ExternalUsers",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FirstName",
                table: "ExternalUsers",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Email",
                table: "ExternalUsers",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "UserAuthToken",
                table: "AuthTokens",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "RandomSecret",
                table: "AuthTokens",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "CsrfToken",
                table: "AuthTokens",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "InternalName",
                table: "PLangs",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "PLangs",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Language",
                table: "Langs",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "LangShortcut",
                table: "Langs",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "InternalName",
                table: "TestTypes",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "TestTypes",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "MimeType",
                table: "TestAssets",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "TestAssets",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "Tests",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "Tests",
                maxLength: 5000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "MimeType",
                table: "CustomTestAssets",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "CustomTestAssets",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "CustomTest",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "CustomTest",
                maxLength: 5000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FileNameWithExtension",
                table: "TemplateFiles",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "TemplateFiles",
                maxLength: 10000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "HtmlIcon",
                table: "Tags",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "HtmlColor",
                table: "Tags",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "HtmlBackgroundColor",
                table: "Tags",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "Tags",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Description",
                table: "Tags",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Protocol",
                table: "TestWithSingleSolutionAsTestResult",
                maxLength: 10000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FileNameWithExtension",
                table: "SolutionFiles",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "SolutionFiles",
                maxLength: 10000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "NoteForOtherTutors",
                table: "SolutionAssessment",
                maxLength: 1000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FeedbackForStudent",
                table: "SolutionAssessment",
                maxLength: 1000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Note",
                table: "Solutions",
                maxLength: 1000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Protocol",
                table: "CustomTestWithSingleSolutionAsTestResult",
                maxLength: 10000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Note",
                table: "ExerciseReleases",
                maxLength: 1000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "GeneratedCode",
                table: "ExerciseReleases",
                maxLength: 500,
                nullable: false);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "ExerciseDescriptions",
                maxLength: 10000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "ShortDescription",
                table: "Exercises",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Note",
                table: "Exercises",
                maxLength: 1000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "Exercises",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "MimeType",
                table: "Assets",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "Assets",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "AssetUrl",
                table: "Assets",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Protocol",
                table: "TestWithAfterSolutionAsTestResults",
                maxLength: 10000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Protocol",
                table: "CustomTestWithAfterSolutionAsTestResults",
                maxLength: 10000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FileNameWithExtension",
                table: "AfterSolutionFiles",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "AfterSolutionFiles",
                maxLength: 10000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Protocol",
                table: "CustomProjectTestWithSolutionAsTestResults",
                maxLength: 10000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "MimeType",
                table: "CustomProjectTestAssets",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "CustomProjectTestAssets",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "CustomProjectTests",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "CustomProjectTests",
                maxLength: 5000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FileNameWithExtension",
                table: "CustomProjectSolutionFiles",
                maxLength: 500,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "CustomProjectSolutionFiles",
                maxLength: 10000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "CustomProjectDescriptions",
                maxLength: 10000,
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "CustomProjects",
                maxLength: 500,
                nullable: true);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "ContentTypes",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    Type = table.Column<string>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ContentTypes", x => x.Id);
                });

            migrationBuilder.AlterColumn<string>(
                name: "Email",
                table: "UserGroups",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "UserGroups",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Token",
                table: "Users",
                nullable: false);

            migrationBuilder.AlterColumn<string>(
                name: "Password",
                table: "Users",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "LastName",
                table: "Users",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FirstName",
                table: "Users",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Email",
                table: "Users",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Email",
                table: "SystemRoles",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "SystemRoles",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Theme",
                table: "UserSettingses",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Theme",
                table: "CodeEditorSettings",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "GroupRoles",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Token",
                table: "ExternalUsers",
                nullable: false);

            migrationBuilder.AlterColumn<string>(
                name: "LastName",
                table: "ExternalUsers",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FirstName",
                table: "ExternalUsers",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Email",
                table: "ExternalUsers",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "UserAuthToken",
                table: "AuthTokens",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "RandomSecret",
                table: "AuthTokens",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "CsrfToken",
                table: "AuthTokens",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "InternalName",
                table: "PLangs",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "PLangs",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Language",
                table: "Langs",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "LangShortcut",
                table: "Langs",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "InternalName",
                table: "TestTypes",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "TestTypes",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "MimeType",
                table: "TestAssets",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "TestAssets",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "Tests",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "Tests",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "MimeType",
                table: "CustomTestAssets",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "CustomTestAssets",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "CustomTest",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "CustomTest",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FileNameWithExtension",
                table: "TemplateFiles",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "TemplateFiles",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "HtmlIcon",
                table: "Tags",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "HtmlColor",
                table: "Tags",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "HtmlBackgroundColor",
                table: "Tags",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "Tags",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Description",
                table: "Tags",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Protocol",
                table: "TestWithSingleSolutionAsTestResult",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FileNameWithExtension",
                table: "SolutionFiles",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "SolutionFiles",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "NoteForOtherTutors",
                table: "SolutionAssessment",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FeedbackForStudent",
                table: "SolutionAssessment",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Note",
                table: "Solutions",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Protocol",
                table: "CustomTestWithSingleSolutionAsTestResult",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Note",
                table: "ExerciseReleases",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "GeneratedCode",
                table: "ExerciseReleases",
                nullable: false);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "ExerciseDescriptions",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "ShortDescription",
                table: "Exercises",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Note",
                table: "Exercises",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "Exercises",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "MimeType",
                table: "Assets",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "Assets",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "AssetUrl",
                table: "Assets",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Protocol",
                table: "TestWithAfterSolutionAsTestResults",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Protocol",
                table: "CustomTestWithAfterSolutionAsTestResults",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FileNameWithExtension",
                table: "AfterSolutionFiles",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "AfterSolutionFiles",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Protocol",
                table: "CustomProjectTestWithSolutionAsTestResults",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "MimeType",
                table: "CustomProjectTestAssets",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "CustomProjectTestAssets",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "CustomProjectTests",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "CustomProjectTests",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "FileNameWithExtension",
                table: "CustomProjectSolutionFiles",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "CustomProjectSolutionFiles",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "Content",
                table: "CustomProjectDescriptions",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "DisplayName",
                table: "CustomProjects",
                nullable: true);
        }
    }
}
