﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class ExerciseMarkdownFiles : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "FileReferenceMarkdownAssets",
                columns: table => new
                {
                    Id = table.Column<int>(nullable: false)
                        .Annotation("Npgsql:ValueGeneratedOnAdd", true),
                    CreatedAt = table.Column<DateTime>(nullable: false),
                    Hash = table.Column<string>(maxLength: 500, nullable: true),
                    LastUpdatedAt = table.Column<DateTime>(nullable: false),
                    MimeType = table.Column<string>(maxLength: 500, nullable: true),
                    OriginalName = table.Column<string>(maxLength: 500, nullable: true),
                    RelativePath = table.Column<string>(maxLength: 5000, nullable: true),
                    SizeInBytes = table.Column<long>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_FileReferenceMarkdownAssets", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "ExerciseDescriptionWithFileAsAssetReferences",
                columns: table => new
                {
                    ExerciseDescriptionId = table.Column<int>(nullable: false),
                    FileReferenceMarkdownAssetId = table.Column<int>(nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ExerciseDescriptionWithFileAsAssetReferences", x => new { x.ExerciseDescriptionId, x.FileReferenceMarkdownAssetId });
                    table.ForeignKey(
                        name: "FK_ExerciseDescriptionWithFileAsAssetReferences_ExerciseDescriptions_ExerciseDescriptionId",
                        column: x => x.ExerciseDescriptionId,
                        principalTable: "ExerciseDescriptions",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_ExerciseDescriptionWithFileAsAssetReferences_FileReferenceMarkdownAssets_FileReferenceMarkdownAssetId",
                        column: x => x.FileReferenceMarkdownAssetId,
                        principalTable: "FileReferenceMarkdownAssets",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseDescriptionWithFileAsAssetReferences_ExerciseDescriptionId",
                table: "ExerciseDescriptionWithFileAsAssetReferences",
                column: "ExerciseDescriptionId");

            migrationBuilder.CreateIndex(
                name: "IX_ExerciseDescriptionWithFileAsAssetReferences_FileReferenceMarkdownAssetId",
                table: "ExerciseDescriptionWithFileAsAssetReferences",
                column: "FileReferenceMarkdownAssetId");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "ExerciseDescriptionWithFileAsAssetReferences");

            migrationBuilder.DropTable(
                name: "FileReferenceMarkdownAssets");
        }
    }
}
