﻿using System;

namespace ClientServer.Models.Users
{
    /// <summary>
    /// a permission only valid for a group and group operations
    /// every permission is only valid for a referred group
    /// </summary>
    public class GroupRolePermission
    {
        [Obsolete("only for ef")]
        public GroupRolePermission()
        {
        }

        public GroupRolePermission(bool CanCreateExercises, bool CanChangeExercises, bool CanDeleteExercises,
            bool CanSeeExercisesFromOthersInGroup, bool canManageExerciseReleases,
            bool CanLockExercisesPermanently,
            bool CanAssessExercises, bool CanAddUserToGroup, bool CanRemoveMemberFromGroup,
            bool CanChangeOtherMembersRole, bool CanSeeOtherMembers, bool CanChangeGroupData)
        {
            this.CanCreateExercises = CanCreateExercises;
            this.CanChangeExercises = CanChangeExercises;
            this.CanDeleteExercises = CanDeleteExercises;
            this.CanSeeExercisesFromOthersInGroup = CanSeeExercisesFromOthersInGroup;
            this.CanManageExerciseReleases = canManageExerciseReleases;
            this.CanLockExercisesPermanently = CanLockExercisesPermanently;
            this.CanAssessExercises = CanAssessExercises;
            this.CanAddUserToGroup = CanAddUserToGroup;
            this.CanRemoveMemberFromGroup = CanRemoveMemberFromGroup;
            this.CanChangeOtherMembersRole = CanChangeOtherMembersRole;
            this.CanSeeOtherMembers = CanSeeOtherMembers;
            this.CanChangeGroupData = CanChangeGroupData;
        }

        public int Id { get; set; }

        //read -> can ... in the group 

        /// <summary>
        /// true: can create new exercises, fale: not
        /// </summary>
        public bool CanCreateExercises { get; set; }

        /// <summary>
        /// true: can change exercises, false: not
        /// </summary>
        public bool CanChangeExercises { get; set; }

        /// <summary>
        /// true: can delete exercises, false: not
        /// </summary>
        public bool CanDeleteExercises { get; set; }

        /// <summary>
        /// true: can see exercises from other users in the group, false: not
        /// if the user guesses the exercise id he still can interact with the exercise...
        /// </summary>
        public bool CanSeeExercisesFromOthersInGroup { get; set; }

        /// <summary>
        /// true: can manage exercise releases (crud), false: not
        /// </summary>
        public bool CanManageExerciseReleases { get; set; }

        /// <summary>
        /// true: can lock exercises, false not
        /// </summary>
        public bool CanLockExercisesPermanently { get; set; }

        /// <summary>
        /// true: can assess/evaulate exercises manually, false: not
        /// </summary>
        public bool CanAssessExercises { get; set; }

        /// <summary>
        /// true: can add a person to the group, false: not
        /// </summary>
        public bool CanAddUserToGroup { get; set; }

        /// <summary>
        /// true: can remove a person from a group, false: not
        /// </summary>
        public bool CanRemoveMemberFromGroup { get; set; }

        /// <summary>
        /// true: can change a role of other users in the group, false: not
        /// </summary>
        public bool CanChangeOtherMembersRole { get; set; }

        /// <summary>
        /// true: can see other members in single group overview (and get all group roles)
        /// false: not
        /// </summary>
        public bool CanSeeOtherMembers { get; set; }

        /// <summary>
        /// true: can change the group data e.g. name, email 
        /// without <see cref="SystemRolePermission.CanChangeGroups"/>
        /// false: not
        /// </summary>
        public bool CanChangeGroupData { get; set; }
    }
}
