﻿using System.ComponentModel.DataAnnotations;
using ClientServer.Db;

namespace ClientServer.Models.Users.Settings
{
    public class UserSetting
    {
        public int Id { get; set; }


        public int CodeEditorSettingsId { get; set; }
        public CodeEditorSetting CodeEditorSetting { get; set; }


        /// <summary>
        /// can be null if the lang gets deleted... use default then
        /// </summary>
        public int? LangId { get; set; }
        public Lang Lang { get; set; }

        /// <summary>
        /// the theme to use (can be null)
        /// </summary>
        [MaxLength(YapexDbContext.DefaultMaxStringLength)]
        public string Theme { get; set; }


        //optional, if null use some default settings
        public int? UserId { get; set; }
        public User User { get; set; }

    }
}
